package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.OrderRepair;
import com.izouma.awesomeadmin.service.OrderRepairService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/orderRepair")
@RequiresAuthentication
public class OrderRepairController {

    @Autowired
    private OrderRepairService orderRepairService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(OrderRepair record) {
        List<OrderRepair> pp = orderRepairService.getOrderRepairList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getOrderRepair", method = RequestMethod.GET)
    @ResponseBody
    public Result getOrderRepair(@RequestParam(required = false, value = "id") String id) {
        OrderRepair data = orderRepairService.getOrderRepairById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(OrderRepair record) {
        OrderRepair data = orderRepairService.getOrderRepair(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, OrderRepair record) {
        Map<String, Object> result = new HashMap<>();

        List<OrderRepair> pp =orderRepairService.getOrderRepairByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(OrderRepair record) {
        boolean num = orderRepairService.createOrderRepair(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateOrderRepair(OrderRepair record) {
        boolean num = orderRepairService.updateOrderRepair(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteOrderRepair(@RequestParam(required = true, value = "id") String id) {

        boolean num = orderRepairService.deleteOrderRepair(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, OrderRepair record) throws Exception {

    List<OrderRepair> orderRepairs = orderRepairService.getOrderRepairList(record);


        String sheetName = "order_repair";
        String titleName = "订单返修数据表";
        String fileName = "订单返修表";
        int columnNumber = 12;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "用户" ,   "订单" ,   "店铺" ,   "状态" ,   "备注" ,   "返修类型"  };
        String[][] dataList = new String[orderRepairs.size()][12];

        for (int i = 0; i < orderRepairs.size(); i++) {

                        dataList[i][0] = String.valueOf(orderRepairs.get(i).getId());
                        dataList[i][1] = String.valueOf(orderRepairs.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(orderRepairs.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(orderRepairs.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(orderRepairs.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(orderRepairs.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(orderRepairs.get(i).getUserId());
                        dataList[i][7] = String.valueOf(orderRepairs.get(i).getOrderId());
                        dataList[i][8] = String.valueOf(orderRepairs.get(i).getStoreId());
                        dataList[i][9] = String.valueOf(orderRepairs.get(i).getStatusFlag());
                        dataList[i][10] = String.valueOf(orderRepairs.get(i).getRemark());
                        dataList[i][11] = String.valueOf(orderRepairs.get(i).getTypeFlag());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

